Kea: isc::dhcp::ClientClassDefParser Class Reference

| Kea 3.2.0-git

isc::dhcp::ClientClassDefParser Class Reference

Parser for a single client class definition. More...

`#include <client_class_def_parser.h>`

Inheritance diagram for isc::dhcp::ClientClassDefParser:
[legend]

## Public Member Functions
virtual | ~ClientClassDefParser ()
| Virtual destructor.
void | checkParametersSupported (const isc::data::ConstElementPtr &class_def_cfg, const uint16_t family)
| Iterates over class parameters and checks if they are supported.
void | parse (ClientClassDictionaryPtr &class_dictionary, isc::data::ConstElementPtr client_class_def, uint16_t family, bool append_error_position=true, bool check_dependencies=true)
| Parses an entry that describes single client class definition.
Public Member Functions inherited from isc::data::SimpleParser
uint16_t | getUint16 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint16_t.
uint32_t | getUint32 (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a value converted to uint32_t.
uint8_t | getUint8 (ConstElementPtr scope, const std::string &name)
| Get an uint8_t value.
const isc::util::Triplet< uint32_t > | parseIntTriplet (const data::ConstElementPtr &scope, const std::string &name)
| Parses an integer triplet.

## Protected Member Functions
virtual boost::shared_ptr< OptionDataListParser > | createOptionDataListParser (const uint16_t address_family, CfgOptionDefPtr cfg_option_def) const
| Returns an instance of the `OptionDataListParser` to be used in parsing the option-data structure.
Protected Member Functions inherited from isc::data::SimpleParser
template<typename target_type, target_type convert>
target_type | getAndConvert (isc::data::ConstElementPtr scope, const std::string &name, const std::string &type_name)
| Returns a converted value from a scope.
template<typename int_type>
int_type | getIntType (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer value with range checking from a scope.

## Additional Inherited Members
Static Public Member Functions inherited from isc::data::SimpleParser
static void | checkKeywords (const SimpleKeywords &keywords, isc::data::ConstElementPtr scope)
| Checks acceptable keywords with their expected type.
static void | checkRequired (const SimpleRequiredKeywords &required, isc::data::ConstElementPtr scope)
| Checks that all required keywords are present.
static size_t | deriveParams (isc::data::ConstElementPtr parent, isc::data::ElementPtr child, const ParamsList &params)
| Derives (inherits) parameters from parent scope to a child.
static isc::asiolink::IOAddress | getAddress (const ConstElementPtr &scope, const std::string &name)
| Returns a IOAddress parameter from a scope.
static bool | getBoolean (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a boolean parameter from a scope.
static double | getDouble (const ConstElementPtr &scope, const std::string &name)
| Returns a floating point parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name)
| Returns an integer parameter from a scope.
static int64_t | getInteger (isc::data::ConstElementPtr scope, const std::string &name, int64_t min, int64_t max)
| Returns an integer parameter from a scope and checks its range.
static const data::Element::Position & | getPosition (const std::string &name, const data::ConstElementPtr parent)
| Utility method that returns position of an element.
static std::string | getString (isc::data::ConstElementPtr scope, const std::string &name)
| Returns a string parameter from a scope.
template<typename T>
static void | rangeCheckedInteger (isc::data::ConstElementPtr scope, const std::string &name, T &output_value)
| Fetches a range-checked integer parameter from a scope.
static size_t | setDefaults (isc::data::ElementPtr scope, const SimpleDefaults &default_values)
| Sets the default values.
static size_t | setListDefaults (isc::data::ConstElementPtr list, const SimpleDefaults &default_values)
| Sets the default values for all entries in a list.

## Detailed Description

Parser for a single client class definition.

This parser creates an instance of a client class definition.

Definition at line 85 of file client_class_def_parser.h.

## Constructor & Destructor Documentation

## ◆ ~ClientClassDefParser()

virtual isc::dhcp::ClientClassDefParser::~ClientClassDefParser | ( |  | ) |
| inlinevirtual

Virtual destructor.

Definition at line 89 of file client_class_def_parser.h.

## Member Function Documentation

## ◆ checkParametersSupported()

void isc::dhcp::ClientClassDefParser::checkParametersSupported | ( | const isc::data::ConstElementPtr & | class_def_cfg,
|  | const uint16_t | family )

Iterates over class parameters and checks if they are supported.

This method should be called by hooks libraries which do not use Bison to validate class syntax prior to parsing the client class information.

Parameters

  class_def_cfg | class configuration entry.
  family | the address family of the client class.

Exceptions

  DhcpConfigError | if any of the parameters is not supported.

Definition at line 335 of file client_class_def_parser.cc.

References isc_throw, and isc::data::Element::map.

Referenced by isc::class_cmds::ClassCmdsImpl::addClass(), and isc::class_cmds::ClassCmdsImpl::updateClass().

## ◆ createOptionDataListParser()

boost::shared_ptr< OptionDataListParser > isc::dhcp::ClientClassDefParser::createOptionDataListParser | ( | const uint16_t | address_family,
|  | CfgOptionDefPtr | cfg_option_def ) const
| protectedvirtual

Returns an instance of the `OptionDataListParser` to be used in parsing the option-data structure.

This function can be overridden in the child classes to supply a custom parser for option data.

Parameters

  address_family | `AF_INET` (for DHCPv4) or `AF_INET6` (for DHCPv6).
  cfg_option_def | structure holding option definitions.

Returns
  an instance of the `OptionDataListParser`.

Definition at line 379 of file client_class_def_parser.cc.

Referenced by parse().

## ◆ parse()

void isc::dhcp::ClientClassDefParser::parse | ( | ClientClassDictionaryPtr & | class_dictionary,
|  | isc::data::ConstElementPtr | client_class_def,
|  | uint16_t | family,
|  | bool | append_error_position = true,
|  | bool | check_dependencies = true )

Parses an entry that describes single client class definition.

Attempts to add the new class directly into the given dictionary. This done here to detect duplicate classes prior to commit().

Parameters

  class_dictionary | dictionary into which the class should be added
  client_class_def | a configuration entry to be parsed.
  family | the address family of the client class.
  append_error_position | Boolean flag indicating if position of the parsed string within parsed JSON should be appended. The default setting is to append it, but it is typically set to false when this parser is used by hooks libraries.
  check_dependencies | indicates if the parser should evaluate an expression to see if the referenced client classes exist.

Exceptions

  DhcpConfigError | if parsing was unsuccessful.

Definition at line 77 of file client_class_def_parser.cc.

References isc::eval::EvalContext::acceptAll(), isc::data::Element::boolean, isc::dhcp::builtinNames, createOptionDataListParser(), isc::dhcp::DHCPSRV_CLASS_WITH_ADDITIONAL_AND_LIFETIMES, isc::dhcp::dhcpsrv_logger, isc::dhcp::DHCPSRV_ONLY_IF_REQUIRED_DEPRECATED, isc::asiolink::IOAddress::getFamily(), isc::data::SimpleParser::getInteger(), isc::data::SimpleParser::getPosition(), isc::data::SimpleParser::getString(), isc_throw, isc::dhcp::isClientClassDefined(), isc::asiolink::IOAddress::isV4Bcast(), LOG_WARN, isc::data::Element::map, isc::dhcp::Pkt4::MAX_FILE_LEN, isc::dhcp::Pkt4::MAX_SNAME_LEN, isc::dhcp::SimpleParser4::OPTION4_DEF_DEFAULTS, isc::dhcp::SimpleParser6::OPTION6_DEF_DEFAULTS, isc::dhcp::ExpressionParser::parse(), isc::dhcp::OptionDefParser::parse(), isc::data::SimpleParser::parseIntTriplet(), isc::eval::EvalContext::PARSER_BOOL, isc::eval::EvalContext::PARSER_STRING, isc::data::SimpleParser::setListDefaults(), isc::dhcp::LibDHCP::shouldDeferOptionUnpack(), and isc::util::Optional< T >::unspecified().

Referenced by isc::class_cmds::ClassCmdsImpl::addClass(), isc::dhcp::ClientClassDefListParser::parse(), and isc::class_cmds::ClassCmdsImpl::updateClass().

Here is the call graph for this function:

The documentation for this class was generated from the following files:

- client_class_def_parser.h
- client_class_def_parser.cc